<!-- title: Zoraxy : changement de reverse-proxy -->
<!-- category: Hébergement -->

J'ai décidé de remplacer [Nginx Proxy Manager](/2024/retour-en-auto-hebergement/) car la maintenance du container Alpine n'est pas aisée avec ma version modifiée pour ne pas exécuter les services du proxy en *root*. Ma première idée a été de revenir à une installation de Nginx classique, fournie par les dépôts Alpine, et à maintenir les fichiers de configuration manuellement. Après tout je l'ai fait pendant des années sur mes multiples installations de serveurs... Mais il semble que la flemme vienne avec l'âge : il y a le maintien de la configuration, la mise en place de [certbot](https://certbot.eff.org/), la surveillance et l'analyse des logs. 

Je me suis demandé s'il y avait une alternative à Nginx Proxy Manager et je suis tombé sur [Zoraxy](https://zoraxy.aroz.org) : un outil tout-en-un qui fait office de reverse-proxy dynamique avec un tableau de bord d'analyse du trafic. Tout-en-un techniquement aussi car c'est une application écrite en Golang donc un binaire unique. En plus de la fonction de proxy HTTP et de la gestion des certificat, des fonctions additionnelles très sympathiques sont proposées via l'interface Web : 
- le support des proxy TCP / UDP (nommés Stream Proxy)
- une surveillance de la disponibilité des services backends (uptime monitor)
- une configuration des pages 404 et un hébergement de pages statiques. je n'ai pas expérimenté  mais on doit pouvoir créer une page d'erreur personnalisée quand un service backend est par terre.
- un tableau de bord assez complet qui permet de réagir et de contrôler les accès en bloquant des IP ou des pays 

Devant l'engouement pour son projet le créateur de Zoraxy a recadré les utilisateurs en insistant sur le fait que Zoraxy ne pouvait pas avoir la robustesse et les performances d'un NginX et qu'il fallait le réserver à des usages plus limités. En cela il se positionne comme *"The ultimate homelab networking toolbox for self-hosted services"* et non pas comme un remplacement du reverse-proxy NginX pour des sites à gros volumes. Cela colle parfaitement à mon usage.    



